#pragma semicolon 1

#include <ws_store>
#include <sourcemod>
#include <sdktools_functions>

new g_Price, Float:g_fBoost, g_CategoryID, g_ItemID;
new g_MyJumps[MAXPLAYERS + 1][2];

public Plugin:myinfo = 
{
	name	= "STORE (Double Jump)",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

public OnPluginStart()
{
	CreateTimer(1.0, START);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_double_jump");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_double_jump.txt"))
		SetFailState("Error in cfg/store/modules/store_double_jump.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	if ((g_fBoost = KvGetFloat(kv, "boost")) < 100.0) g_fBoost = 100.0;

	CloseHandle(kv);
	/////

	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы мертвы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_MyJumps[client][1] > 0)
	{
		PrintCenterText(client, "Вы уже купили двойной прыжок");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_MyJumps[client][1] = 1;
	PrintToChat(client, "\x04Вы купили двойной прыжок");

	STORE_ShowMenu(client, MI);
}


///


public OnClientPutInServer(client)
{
	g_MyJumps[client][1] = 0;
}

public OnClientDisconnect(client)
{
	g_MyJumps[client][1] = 0;
}

public round_start(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++) g_MyJumps[i][1] = 0;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (g_MyJumps[client][1] < 1 || !IsPlayerAlive(client))
			return Plugin_Continue;

	if (GetEntityFlags(client) & FL_ONGROUND)
		g_MyJumps[client][0] = 1;

	else if (buttons & IN_JUMP && g_MyJumps[client][0] > 0)
	{
		decl Float:V[3];
		GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", V);
		if (V[2] < 0.0)
		{
			--g_MyJumps[client][0];
			decl Float:Vec[3];
			GetAngleVectors(Float:{-90.0,0.0,0.0}, Vec, NULL_VECTOR, NULL_VECTOR);
			NormalizeVector(Vec, Vec);
			ScaleVector(Vec, g_fBoost);
			V[0] += Vec[0];
			V[1] += Vec[1];
			V[2]  = Vec[2];
			TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, V);
		}
	}

	return Plugin_Continue;
}